from Plugins.Extensions.myfreemp3.Moduli.imports import *
from Plugins.Extensions.myfreemp3.Moduli.Player import *
from Plugins.Extensions.myfreemp3.Moduli.Setup import *
 
DirFileJobs = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/LogDownload/LogDownload'
DirFileJobsInfo = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/LogDownload/LogInfo'
DirFileErrorJobs = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/LogDownload/errors'

class DownloadJob:
    def __init__(self, url, name, status = 'new', filesize = 0, filetype = 'mp4'):
        self.url = url
        self.name = name
        self.filetype = filetype
        self.filename = '%s/%s.%s' % (DlPath(), self.name.replace('flv','').replace('mp3',''), self.filetype)
        self.filesize = filesize
        self.filesizeInMB = 0
        self.status = status
        self.percentageProgress = 0

    def startDownload(self):
        self.status = 'downloading'
        self.currentDownload = downloadWithProgress(self.url, self.filename)
        self.currentDownload.addProgress(self.setProgress)
        self.currentDownload.start().addCallback(self.downloadFinished).addErrback(self.downloadFailed)

    def stopDownload(self):
        self.status = 'stopped'
        self.currentDownload.stop()

    def setProgress(self, receivedBytes, totalBytes):
        self.percentageProgress = int(float(receivedBytes) / float(totalBytes) * 100)
        if self.filesize == 0:
          buf = []
          jobFile = open(DirFileJobs, 'r')
          for line in jobFile:
            linesplit = line.split('^^')
            if linesplit[1] == self.name and len(linesplit) == 3:
              line = line.replace('\n', '^^%s' % totalBytes)
              line = line + '\n'
            buf.append(line)
          jobFile.close()
          newJobFile = open(DirFileJobs, 'w')
          for line in buf:
            newJobFile.write(line)
          newJobFile.close()
        self.filesize = totalBytes
        self.filesizeInMB = int(totalBytes / 1024 / 1024)

    def downloadFinished(self, string = None):
        if string is not None:
          buf = []
          jobFile = open(DirFileJobs, 'r')
          for line in jobFile:
            linesplit = line.split('^^')
            if linesplit[1] == self.name:
              line = line.replace(linesplit[2], string)
            buf.append(line)
          jobFile.close()
          newJobFile = open(DirFileJobs, 'w')
          for line in buf:
            newJobFile.write(line)
          newJobFile.close()
        else:
          if self.status != 'stopped':
            self.status = 'finished'
          buf = []
          jobFile = open(DirFileJobs, 'r')
          for line in jobFile:
            linesplit = line.split('^^')
            if linesplit[1] == self.name:
              line = line.replace(linesplit[2], self.status)
            buf.append(line)
          jobFile.close()
          newJobFile = open(DirFileJobs, 'w')
          for line in buf:
            newJobFile.write(line)
          newJobFile.close()
          Notifications.AddNotification(MessageBox, _('Download of %s has finished') % self.name, type=MessageBox.TYPE_INFO, timeout=10)
          self.nextDownload = ''
          self.nextDownload = jm.getNextJob()
          if self.nextDownload is not None:
            jm.startDownload(self.nextDownload)

    def downloadFailed(self, error = None, errorText = ''):
        if error:
          if errorText == '':
            errorText = error.getErrorMessage()
          if errorText != '200 OK':
            self.status = 'error'
            buf = []
            jobFile = open(DirFileJobs, 'r')
            for line in jobFile:
              linesplit = line.split('^^')
              if linesplit[1] == self.name:
                line = line.replace(linesplit[2], self.status)
              buf.append(line)
            jobFile.close()
            newJobFile = open(DirFileJobs, 'w')
            for line in buf:
              newJobFile.write(line)
            newJobFile.close()
            errorFile = open(DirFileErrorJobs, 'a')
            errorFile.write('%s^^%s\n' % (self.name, errorText))
            errorFile.close()

class JobManager:
    def __init__(self):
        self.jobList = []
                
    def addJobToList(self, url, name,cover='',trama='',type = 'mp4'):
        self.jobStatus = 'new'
        self.newJob = [url, name, self.jobStatus]
        jobFile = open(DirFileJobs, 'a')
        jobFile.write('%s^^%s^^%s\n' % (url, name, self.jobStatus))
        jobFile.close()	
        jobFileA = open(DirFileJobsInfo, 'a')
        jobFileA.write('%s^^%s^^%s\n' % (cover,trama,name))
        jobFileA.close()	
        currentDownload = DownloadJob(url, name,'new',0,type)
        self.jobList.append(currentDownload)	
        return currentDownload
                
    def removeJobFromListInfo(self, name):		
        try:		
          jobFile = open(DirFileJobsInfo, 'r')
        except:
          pass					
        try:		
          iList=[]			 
          for line in jobFile:
            linesplit = line.split('^^')			
            if not str(linesplit[2]).strip().find(str(name)) != -1:		
              iList.append(line)	
          jobFile.close()
        except :
          pass		
        try:		
          jobFile = open(DirFileJobsInfo, 'w')
        except:
          pass	
        try:		
          for x in iList:
            jobFile.write(str(x.strip())+'\n')
          jobFile.close()	 
        except:
          pass				

    def removeJobFromList(self, name):
        for (i, job) in enumerate(self.jobList):
          if job.name == name:
            self.removeJobFromListInfo(name)	
            del self.jobList[i]
            break

    def startDownload(self, job = None):
        if job == None:
          for currentDownload in self.jobList:
            if currentDownload.status == 'new' or currentDownload.status == 'stopped':
              currentDownload.startDownload()
        elif job.status == 'new' or job.status == 'stopped':
          job.startDownload()

    def stopDownload(self, job = None):
        if job == None:
          for currentDownload in self.jobList:
            if currentDownload.status == 'downloading':
              currentDownload.stopDownload()
        elif job.status == 'downloading':
          job.stopDownload()

    def readJobs(self):
        self.ArcList =[]
        if fileExists(DirFileJobs):
          jobFile = open(DirFileJobs, 'r')
          for line in jobFile:
            linesplit = line.split('^^')
            status = linesplit[2].strip('\n\r')
            size = 0
            if len(linesplit) == 4:
              size = linesplit[3]
                                    
            if linesplit[2] != 'downloading':
              currentDownload = DownloadJob(linesplit[0], linesplit[1], status, size)	
              if str(self.jobList).find(str(linesplit[0])) != -1 :              
                self.jobList.append(currentDownload)
              else:
                self.ArcList.append(currentDownload)			
          jobFile.close()
                        
        if not self.jobList:
          self.jobList = self.ArcList
                
    def getNextJob(self):
        for job in self.jobList:
          if job.status == 'new':
            return job
          break
                        
    def getCurrentDownloads(self):
        self.currentDownloadsList = []
        for job in self.jobList:
          if job.status == 'downloading':
            self.currentDownloadsList.append(job)
        return self.currentDownloadsList

    def getJob(self, name = None):
        if name is not None:
          for job in self.jobList:
            if job.name == name:
              return job
            break
jm = JobManager()













