# -*- coding: UTF-8 -*-
from Moduli.imports import *
from Moduli.Setup import *
from Moduli.JobsMs import *           
from Moduli.MediaMessage import MessageManager
from Moduli.MediaMenuList import chooseMenuListD,chooseMenuListE,chooseMenuList,chooseMenuListA
from Components.Label import Label
from Components.ScrollLabel import ScrollLabel
from Components.ActionMap import  ActionMap
from Components.MenuList import MenuList
from Components.Pixmap import Pixmap
from enigma import  loadPic, eTimer, eConsoleAppContainer, eServiceReference
from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.VirtualKeyBoard import VirtualKeyBoard
import os,re, datetime, urllib,json
from Components.ServiceEventTracker import  InfoBarBase
from Components.config import configfile, getConfigListEntry, ConfigEnableDisable, ConfigYesNo, ConfigText, ConfigDateTime, ConfigClock, ConfigNumber, ConfigSelectionNumber, ConfigSelection, config, ConfigSubsection, ConfigSubList, ConfigSubDict, ConfigIP, ConfigSlider, ConfigDirectory, ConfigInteger
from Screens.InfoBarGenerics import InfoBarSeek
from twisted.web.client import getPage

Version = "1.0.1"
Description_plug = "MyFreeMp3\xae"

class MyFreeMp3Screen(Screen,InfoBarBase, InfoBarSeek):

    def __init__(self, session, currentList,url):
        self.session = session
        skin = "/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/MyFreeMp3.xml"
        if os.path.exists(skin):
            f = open(skin, 'r')
            self.skin = f.read()
            f.close()
        Screen.__init__(self, session)
        InfoBarBase.__init__(self)
        InfoBarSeek.__init__(self)	
        self.Url	= url		
        self.jcurrentList = currentList
        self.Storage = '/media/usb/movie'		
        self.keyLocked = True		
        self.playing = False	
        self.currentList = "MainList"		
        self.MainList = []		
        self.EnterLocation	= ''
        self["MainList"] = MenuList(self.MainList)    
        self.PrimoPianoList = []		
        self["PrimoPianoList"] = MenuList(self.PrimoPianoList) 
        self['Yellow'] = Pixmap()
        self['Yellow'].hide()		
        self['durata'] = Label("")	
        self['titolo'] = Label("")					
        self["onda"] = Label("")
        self['Green'] = Pixmap()
        self['Green'].show()
        self['Blue'] = Pixmap()
        self['Blue'].show() 	
        self["Key_Red"] = Label(_("Exit"))											
        self["Key_Green"] = Label(_("Rec"))	
        self["Key_Yellow"] = Label(_("Pause"))		
        self["Key_Blu"] = Label(_("Menu"))
        self.lastservice = session.nav.getCurrentlyPlayingServiceReference()		
        self.MenuStart()
        if self.jcurrentList == 'MainList' or self.jcurrentList == 'PrimoPianoList':	
            self.keySwitchList()		
        self["myActionMap"] = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"],
        {							
        "ok": self.go,		
        "cancel": self.cancel,						
        "red": self.cancel,
		"green": self.Download,
        "left":self.MoveUp,
        "right":self.MoveDown,
        "nextBouquet" : self.keySwitchList,
        "prevBouquet" : self.keySwitchList,		
        "up":self.Up,
        "down":self.Down			
        }, -1)		
		
    def Info(self):
        try:	
            self['durata'].setText('Durata: '+self["MainList"].l.getCurrentSelection()[2])		
            self['titolo'].setText('Titolo: '+self["MainList"].l.getCurrentSelection()[0])
        except:
            self['durata'].setText('')		
            self['titolo'].setText('')
		
    def MenuStart(self):
        self.keyLocked = True
        self['onda'].setText(_('Wait Please...'))		
        if self.jcurrentList == 'MainList':			
            getPage(self.Url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.Artists).addErrback(self.dataError)
        elif self.jcurrentList == 'PrimoPianoList':								
            getPage(self.Url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.Genres).addErrback(self.dataError)  
        else:			
            getPage(self.Url, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.jMainList).addErrback(self.dataError)			
            self.SearchList()

    def SearchList(self): 
        self.PrimoPianoList = [(self.jcurrentList)]
        self['PrimoPianoList'].setList(self.PrimoPianoList)
        self['onda'].setText('')			
        self["PrimoPianoList"].selectionEnabled(0)
        self["MainList"].selectionEnabled(1)
        self.currentList = "MainList"	
        self.jcurrentList = 'search'
		
    def Artists(self,html): 
        self.PrimoPianoList = []
        try:	
            reg = re.compile('<li><a class="hash" href="(.+?)">(.+?)<\/a><\/li>',re.DOTALL).findall(html) 
            for link,name in reg:	
                self.PrimoPianoList.append((HTML(name).replace('mp3','').title(),'http://myfreemp3.cc'+link.replace(' ','%20')))	
        except:
            self.session.open(MessageBox, MessageManager, "Spiacente il contenuto di questa sezione e' momentaneamente non disponibile!\nRiprova piu tardi..", MessageBox.TYPE_ERROR, timeout=5)		
        self['PrimoPianoList'].setList(self.PrimoPianoList)
        self['onda'].setText('')			
        self.keyLocked = False				
                
    def Genres(self,html): 		
        self.PrimoPianoList = []
        try:	
            reg =  re.compile('<a class="hash artwork" href="(.+?)"><span><img src="(.+?)"></span>(.+?)</a></li>',re.DOTALL).findall(html) 
            for link,jpg,name in reg:	
                   self.PrimoPianoList.append((HTML(name).replace('mp3',''),'http://myfreemp3.cc'+link.replace(' ','%20').replace('artist','music')))	
        except:
            self.session.open(MessageBox, MessageManager, "Spiacente il contenuto di questa sezione e' momentaneamente non disponibile!\nRiprova piu tardi..", MessageBox.TYPE_ERROR, timeout=5)		
        self['PrimoPianoList'].setList(self.PrimoPianoList)
        self['onda'].setText('')		
        self.keyLocked = False	  

    def Menuprimari(self):
        self.keyLocked = True
        self['onda'].setText(_('Wait Please...'))
        getPage(self["PrimoPianoList"].l.getCurrentSelection()[1], headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.jMainList).addErrback(self.dataError)		

    def jMainList(self,html): 		
        self.MainList = []
        try:	
            reg = re.compile('<div class="play"></div></div><a class="info" data-aid="(.+?)" data-current="0" data-duration=".+?">(.+?)</a><div class="add_panel"><div class="track_time">(.+?)</div>',re.DOTALL).findall(html) 	
            for id,name,jtimer in reg:	
                   self.MainList.append((HTML(name).replace('mp3',''),id,jtimer))	
        except:
            self.session.open(MessageBox, MessageManager, "Spiacente il contenuto di questa sezione e' momentaneamente non disponibile!\nRiprova piu tardi..", MessageBox.TYPE_ERROR, timeout=5)		
        self['MainList'].setList(self.MainList)
        self['onda'].setText('')		
        self.keyLocked = False	
        self["PrimoPianoList"].selectionEnabled(0)
        self["MainList"].selectionEnabled(1)		
        self["Key_Green"].setText('Rec')
        self.Info()		
			
    def dataError(self,data): 
        pass
                          
    def doEofInternal(self, playing):
        self['MainList'].down()
        self.go()

    def lockShow(self):
        pass
                
    def unlockShow(self):
        pass		                             	
    
    def MoveUp(self): 
        if self.keyLocked:
            return	  	
        self[self.currentList].pageUp() 
        self.Info()	
		 
    def MoveDown(self):
        if self.keyLocked:
            return	  	
        self[self.currentList].pageDown()	
        self.Info()	
		 
    def Up(self):         
         if self.keyLocked:
            return	  	  
         self[self.currentList].instance.moveSelection(self[self.currentList].instance.moveUp)  	
         self.Info()		 
                 
    def Down(self):    
         if self.keyLocked:
            return	  	
         self[self.currentList].instance.moveSelection(self[self.currentList].instance.moveDown)     
         self.Info()	
		 
    def cancel(self):	
        self.playing = False	
        self.close()
 
    def keySwitchList(self):			
        if self.currentList == "MainList":
            if self.jcurrentList == 'search' :
		return
            self["MainList"].selectionEnabled(0)
            self["PrimoPianoList"].selectionEnabled(1)
            self.currentList = "PrimoPianoList"
            self['durata'].setText('')		
            self['titolo'].setText('')		
            self["Key_Green"].setText('')
        elif self.currentList == "PrimoPianoList":
            if not self.MainList:
		return		
            self["PrimoPianoList"].selectionEnabled(0)
            self["MainList"].selectionEnabled(1)
            self.currentList = "MainList"		
            self["Key_Green"].setText('Rec')
        else:
            pass
			
    def go(self):
        if self.currentList == "MainList":	
            if not self.MainList:
		return
            self.keyLocked = True
            self['onda'].setText(_('Wait Please...'))
            getPage('http://unref.eu/%s'%self["MainList"].l.getCurrentSelection()[1], headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.play).addErrback(self.dataError)
        else:
            self.Menuprimari()
            self["PrimoPianoList"].selectionEnabled(0)
            self["MainList"].selectionEnabled(1)
            self.currentList = "MainList"	            
        
    def play(self,html):		
        try:	
            url = re.compile('window.open\("(.+?)"\);',re.DOTALL).findall(html)[0] 	
            self.session.nav.stopService()   				
            sref = eServiceReference(0x1001, 0, url)
            sref.setName(self["MainList"].l.getCurrentSelection()[0])				
            self.session.nav.playService(sref)
            self.playing = True				
        except:
            pass	
        self['onda'].setText('')		
        self.keyLocked = False	
		
    def Download(self):	
        getPage('http://unref.eu/%s'%str(self["MainList"].l.getCurrentSelection()[1]), headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.Download1).addErrback(self.dataError)	
                
    def Download1(self,html):			
        if self.currentList != 'MainList':
          return  
        Storage,Download,Buffering = load()
        if Download == '':
          self.session.open(MessageManager,2)	
          return	  
        if self.keyLocked:
          return	
        self.keyLocked = True		
        Title = self["MainList"].l.getCurrentSelection()[0]	
        url = re.compile('window.open\("(.+?)"\);',re.DOTALL).findall(html)[0] 			
        if url:		
          self.currentDownload = ''
          self.currentDownload = jm.addJobToList(url,Title.replace(' ','_'),'','','mp3')
          jm.startDownload(self.currentDownload)
          self.session.open(MessageManager,4,Title)	
        else:		
          self.session.open(MessageManager,3)		
        self.keyLocked = False
    
class MyFreeMp3Main(Screen):        
    def __init__(self, session):     
        self.session = session	
        skin = "/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/MyFreeMp3.xml"
        if os.path.exists(skin):  
            f = open(skin, "r")
            self.skin = f.read()
            f.close()						
        Screen.__init__(self, session)					
        self.MainList = []		
        self["MainList"] = MenuList(self.MainList)    
        self.PrimoPianoList = []		
        self["PrimoPianoList"] = MenuList(self.PrimoPianoList)  
        self.Url = None	
        self.currentList = "MainList"
        self['durata'] = Label("")	
        self['titolo'] = Label("")					
        self["onda"] = Label("")
        self['Green'] = Pixmap()
        self['Green'].show()
	self['Yellow'] = Pixmap()
        self['Yellow'].hide()
        self['Blue'] = Pixmap()
        self['Blue'].show()
        self['cover'] = Pixmap()
        self['cover1'] = Pixmap()
        self['cover2'] = Pixmap()
        self['cover3'] = Pixmap()
        self['titolo'] = Label("")		
        self["Key_Red"] = Label(_("Exit"))							
        self["Key_Yellow"] = Label(_("Stop"))			
        self["Key_Green"] = Label(_("Search"))	   
        self["Key_Blu"] = Label(_("Menu"))					
        self.playing = False
        self["PrimoPianoList"].selectionEnabled(0)
        self["MainList"].selectionEnabled(1)		
        self.MenuStart1()	 		
        self.MenuStartmain()	 		
        self.keySwitchList()		
        self["myActionMap"] = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"],
        {							
        "ok": self.go,		
        "cancel": self.cancel,
        'yellow': self.jMainList,		
        "green": self.KeyBoard,			
        "red": self.cancel,					
        "left":self.MoveUp,
        "right":self.MoveDown,
        "nextBouquet" : self.keySwitchList,
        "prevBouquet" : self.keySwitchList,		
        "up":self.Up,
        "down":self.Down			
        }, -1)

    def Info(self):
        try:
            self['durata'].setText('Durata: '+self["MainList"].l.getCurrentSelection()[2])		
            self['titolo'].setText('Titolo: '+self["MainList"].l.getCurrentSelection()[0])
            self['titolo'].setText(HTML(str(self[self.currentList].l.getCurrentSelection()[0])))
            self.keyLocked = True
            picon = str(self[self.currentList].l.getCurrentSelection()[2]).replace(' ','%20')
            downloadPage(picon, '/tmp/phIcon.jpg').addCallback(self.ShowCover).addErrback(self.dataError)
        except:
	        pass
        self['durata'].setText('')		
        self['titolo'].setText('')		
               
    def MenuStartmain(self):
        self.keyLocked = True
        self['onda'].setText(_('Wait Please...'))
        getPage('http://myfreemp3.cc/genres/', headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.MenuStart2).addErrback(self.dataError)        
        
    def MenuStart1(self):
        self.MainList=[]
	self.MainList.append(('                   Поиск по первым буквам Груп и Исполнителей', None))
        self.MainList.append(('0..9','http://myfreemp3.cc/artists/'))
        self.MainList.append(('A' ,'http://myfreemp3.cc/artists/'))
        self.MainList.append(('B','http://myfreemp3.cc/artists/'))
        self.MainList.append(('C','http://myfreemp3.cc/artists/'))
        self.MainList.append(('D','http://myfreemp3.cc/artists/'))
        self.MainList.append(('E','http://myfreemp3.cc/artists/'))
        self.MainList.append(('F','http://myfreemp3.cc/artists/'))
        self.MainList.append(('G','http://myfreemp3.cc/artists/'))
        self.MainList.append(('H','http://myfreemp3.cc/artists/'))
        self.MainList.append(('I','http://myfreemp3.cc/artists/'))
        self.MainList.append(('J','http://myfreemp3.cc/artists/'))
        self.MainList.append(('K','http://myfreemp3.cc/artists/'))
        self.MainList.append(('L','http://myfreemp3.cc/artists/'))
        self.MainList.append(('M','http://myfreemp3.cc/artists/'))
        self.MainList.append(('N','http://myfreemp3.cc/artists/'))
        self.MainList.append(('O','http://myfreemp3.cc/artists/'))
        self.MainList.append(('P','http://myfreemp3.cc/artists/'))
        self.MainList.append(('Q','http://myfreemp3.cc/artists/'))
        self.MainList.append(('R','http://myfreemp3.cc/artists/'))
        self.MainList.append(('S','http://myfreemp3.cc/artists/'))
        self.MainList.append(('T','http://myfreemp3.cc/artists/'))
        self.MainList.append(('U','http://myfreemp3.cc/artists/'))
        self.MainList.append(('V','http://myfreemp3.cc/artists/'))
        self.MainList.append(('W','http://myfreemp3.cc/artists/'))
        self.MainList.append(('X','http://myfreemp3.cc/artists/'))
        self.MainList.append(('Y','http://myfreemp3.cc/artists/'))
        self.MainList.append(('Z','http://myfreemp3.cc/artists/'))
	self.MainList.append(('    Русские исполнители', None))
        self.MainList.append(('а','http://myfreemp3.cc/artists/'))
        self.MainList.append(('б','http://myfreemp3.cc/artists/'))
        self.MainList.append(('в','http://myfreemp3.cc/artists/'))
        self.MainList.append(('г','http://myfreemp3.cc/artists/'))
        self.MainList.append(('д','http://myfreemp3.cc/artists/'))
        self.MainList.append(('е','http://myfreemp3.cc/artists/'))
        self.MainList.append(('ё','http://myfreemp3.cc/artists/'))
        self.MainList.append(('ж','http://myfreemp3.cc/artists/'))
        self.MainList.append(('з','http://myfreemp3.cc/artists/'))
        self.MainList.append(('и','http://myfreemp3.cc/artists/'))
        self.MainList.append(('й','http://myfreemp3.cc/artists/'))
        self.MainList.append(('к','http://myfreemp3.cc/artists/'))
        self.MainList.append(('л','http://myfreemp3.cc/artists/'))
        self.MainList.append(('м','http://myfreemp3.cc/artists/'))
        self.MainList.append(('н','http://myfreemp3.cc/artists/'))
        self.MainList.append(('о','http://myfreemp3.cc/artists/'))
        self.MainList.append(('п','http://myfreemp3.cc/artists/'))
        self.MainList.append(('р','http://myfreemp3.cc/artists/'))
        self.MainList.append(('с','http://myfreemp3.cc/artists/'))
        self.MainList.append(('т','http://myfreemp3.cc/artists/'))
        self.MainList.append(('у','http://myfreemp3.cc/artists/'))
        self.MainList.append(('ф','http://myfreemp3.cc/artists/'))
        self.MainList.append(('х','http://myfreemp3.cc/artists/'))
        self.MainList.append(('ч','http://myfreemp3.cc/artists/'))
        self.MainList.append(('ш','http://myfreemp3.cc/artists/'))
        self.MainList.append(('щ','http://myfreemp3.cc/artists/'))
        self.MainList.append(('ю','http://myfreemp3.cc/artists/'))
        self.MainList.append(('я','http://myfreemp3.cc/artists/'))
        self["MainList"].l.setList(self.MainList)  	
        self['onda'].setText('')		
        self.keyLocked = False	
        self["PrimoPianoList"].selectionEnabled(0)
        self["MainList"].selectionEnabled(1)
			
    def MenuStart2(self,data):				
        self.PrimoPianoList  = []
        reg = re.compile('<a class="hash" href="(.+?)">(.+?)<\/a><\/li>',re.DOTALL).findall(data) 
        for link,name in reg:
              self.PrimoPianoList.append((name,'http://myfreemp3.cc'+link))					
        self["PrimoPianoList"].l.setList(self.PrimoPianoList)  	
        self['onda'].setText('')
        self['Key_Blu'].setText('')		
        self.keyLocked = False	

    def KeyBoard(self):
         self.session.openWithCallback(lambda x : self.VirtualKeyBoardCallback(x),VirtualKeyBoard,title = (_("Title search:")), text = '')
                
    def VirtualKeyBoardCallback(self, callback = None):
        if callback is not None and len(callback):
            Search = callback.replace(' ','+').strip()
            url = 'http://myfreemp3.cc/music/%s'%Search		
            self.session.open(MyFreeMp3Screen,'Risultato ricerca : %s'%callback,url)
			
    def hauptListEntryMenuA(self, name, link, img, descr):
        res = [(name,link, img,descr)]
        if StatusSkin == 'HD':
          res.append(MultiContentEntryText(pos=(12, 5), size=(520, 44), font=2, text=name, flags=RT_HALIGN_LEFT))
          res.append(MultiContentEntryText(pos=(0, 0), size=(0, 0), font=0, text=link, flags=RT_HALIGN_LEFT))
          res.append(MultiContentEntryText(pos=(0, 0), size=(0, 0), font=0, text=img, flags=RT_HALIGN_LEFT))
          res.append(MultiContentEntryText(pos=(0, 0), size=(0, 0), font=0, text=descr, flags=RT_HALIGN_LEFT))
        else:
          res.append(MultiContentEntryText(pos=(12, 5), size=(285, 40), font=2, text=name, flags=RT_HALIGN_LEFT))
          res.append(MultiContentEntryText(pos=(0, 0), size=(0, 0), font=0, text=link, flags=RT_HALIGN_LEFT))
          res.append(MultiContentEntryText(pos=(0, 0), size=(0, 0), font=0, text=img, flags=RT_HALIGN_LEFT))
          res.append(MultiContentEntryText(pos=(0, 0), size=(0, 0), font=0, text=descr, flags=RT_HALIGN_LEFT))
        return res		

    def ShowCover(self, data):
        try:
          png = loadPic('/tmp/phIcon.jpg', 165, 220, 0, 0, 0, 1)
          self['cover'].instance.setPixmap(png)
          self['cover'].show()
        except:
          pass			
			
    def dataError(self,data): 
            pass
                          
    def MoveUp(self): 
        if self.keyLocked:
            return	  	
        self[self.currentList].pageUp() 
                         
    def MoveDown(self):
        if self.keyLocked:
            return	  	
        self[self.currentList].pageDown()	
                         
    def Up(self):         
         if self.keyLocked:
            return	  	  
         self[self.currentList].instance.moveSelection(self[self.currentList].instance.moveUp)  			
                 
    def Down(self):    
         if self.keyLocked:
            return	  	
         self[self.currentList].instance.moveSelection(self[self.currentList].instance.moveDown)     			
                 
    def cancel(self):
        os.system('rm -fr /tmp/phIcon.jpg')
        self.close()

    def jMainList(self):
        self.session.nav.stopService()		
				
    def keySwitchList(self):			
        if self.currentList == "MainList":
            self["MainList"].selectionEnabled(0)
            self["PrimoPianoList"].selectionEnabled(1)
            self.currentList = "PrimoPianoList"
        else:
            self["PrimoPianoList"].selectionEnabled(0)
            self["MainList"].selectionEnabled(1)
            self.currentList = "MainList"	                      
        
    def go(self): 
        if self.keyLocked:
            return		
        if self.currentList == 'MainList':			
            self.Url = 	'http://myfreemp3.cc/artists/%s/'%str(self["MainList"].l.getCurrentSelection()[0]).lower()	
        else:					
            self.Url = 	self["PrimoPianoList"].l.getCurrentSelection()[1]			
        self.session.open(MyFreeMp3Screen,self.currentList,self.Url)
                        
def Main(session, **kwargs):
        session.open(MyFreeMp3Main)

def Plugins(**kwargs):
        return PluginDescriptor(name = Description_plug, description = Description_plug+' '+Version, icon = 'mfmp3.png', where = [PluginDescriptor.WHERE_EXTENSIONSMENU,PluginDescriptor.WHERE_PLUGINMENU], fnc = Main)
                        
                         
